#!/usr/bin/python
#===============================================================================
# CERN (BE-CO-HT)
# Pulse test script
#===============================================================================
# author: Denia Bouhired(t.stana@cern.ch)
#
# date of creation:
#
# version: 1.0
#
# description:
# This script is used during manual upgrade of conv-ttl boards.
# It is used to:
# Read barcodes on card using card reader
#
#===============================================================================
# GNU LESSER GENERAL PUBLIC LICENSE
#===============================================================================
# This source file is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by the
# Free Software Foundation; either version 2.1 of the License, or (at your
# option) any later version. This source is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Lesser General Public License for more details. You should have
# received a copy of the GNU Lesser General Public License along with this
# source; if not, download it from http://www.gnu.org/licenses/lgpl-2.1.html
#===============================================================================

#===============================================================================
#  TODO: -
#===============================================================================
import time
import sys
import time
sys.path.append("../ei2c")
from ei2c import *
import ei2cdefine
import binascii
import re
import subprocess
import os



##-------------------------------------------------------------------------------------------------
## Method to turn on the VME crate.
##-------------------------------------------------------------------------------------------------
## It calls the men-on script which sends the necessary SMTP commands to the ELMA crate to turn on
## power to the VME backplane.
##-------------------------------------------------------------------------------------------------
def men_on():
    print("Switching on the ELMA crate")
    subprocess.call("shell/men-on", shell=True, stdout=fnull, stderr=fnull)
    time.sleep(1)

##-------------------------------------------------------------------------------------------------
## Method to turn off the VME crate.
##-------------------------------------------------------------------------------------------------
## It calls the men-off script which sends the necessary SMTP commands to the ELMA crate to turn off
## power to the VME backplane.
##-------------------------------------------------------------------------------------------------
def men_off():
    print("Switching off the ELMA crate")
    subprocess.call("shell/men-off", shell=True, stdout=fnull, stderr=fnull)
    time.sleep(1)
    
    
    # Turn off the VME crate
    men_off()

    # Scan the first barcode
    while True:
        sn1 = raw_input("--> Scan the 1st barcode: ")
        if (not len(sn1)):
            sn1 = "0"
        m = re.search(r"[^a-z\-A-Z0-9_]+",sn1)
        if m:
            print "Bad character in barcode"
        else:
            break

    # Scan the second barcode
    while True:
        sn2 = raw_input("--> Scan the 2nd barcode: ")
        if len(sn2) > 2:
            m = re.search(r"[^a-z\-A-Z0-9_]+",sn2)
            if m:
                print "Bad character in barcode"
            else:
                break
        else:
            sn2 = "0"
            break
            
# Ask the user to plug in the board, turn on the crate and call the script to download bitstream
    # to FPGA
    msg = "\n--> Plug the CONV-TTL-BLO board '%s-%s' into the VME crate.\n    Then type 'ok': " % (sn1, sn2)
    ok = raw_input(msg)
    while True:
        if ok.find("ok") != -1 or ok.find("OK") != -1:
            break
        else:
            ok = raw_input("--> Please type 'ok' to continue: ")
    print "\n"
    
    # Turn on the VME crate
    men_on()